
/*
 *  basename.c
 *  Copyright (C) 1999 Brad Proctor
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Id: basename.c,v 1.2 1999/06/14 23:24:05 brad Exp $
 */
 
#include <stdio.h>
#include <string.h>
#include "version.h"

static char help_text[] =
{
   "Usage: basename string [suffix]\n\n"
   "  --help     Print this help message\n"
   "  --version  Print the program version\n\n"
   "Report bugs to fredlie@sprynet.com"
};

/*
 * Main
 */

int main(int argc, char **argv)
{
   char *ptr, *ptr1;

   if(argc < 2)
   {
      fprintf(stderr, "%s: Too few arguments\n", argv[0]);
      fprintf(stderr, "Try `%s --help' for more information.\n", argv[0]);
      return (0);
   }

   ptr = argv[1];   
   if(!strcmp(ptr, "--help"))
   {
      puts(help_text);
      return (0);
   }
   else if(!strcmp(ptr, "--version"))
   {
      puts("basename (butils) "VERSION_STRING);
      return (0);
   }
   while(1)
   {
      if(*ptr != '/')
         break;
      else if(*ptr == '\0')
      {
         putchar('\n');
         return (0);
      }
      ++ptr;
   }
   ptr = argv[1];
   while((ptr1 = strrchr(ptr, '/')) != NULL)
      *ptr1 = '\0';
   while((ptr1 = strchr(ptr, '/')) != NULL)
      ptr = ptr1 + 1;
   if(argc > 2)
   {
      ptr1 = argv[2];
      if((ptr1 = strstr(ptr, ptr1)) != NULL)
         if(ptr1 == ptr + strlen(ptr) - strlen(argv[2]))
            *(ptr + (int)ptr1) = '\0';
   }
   puts(ptr);
   return (0);
}